<?php
add_action('init', 'post_type_product');
function post_type_product() {
    register_post_type( 'product',
        array(
            'labels' => array(
                'name' => '小程序',
                'singular_name' => 'porduct',
                'add_new' => '添加',
                'add_new_item' => '添加',
                'edit_item' => '编辑',
                'new_item' => 'New'
            ),
        'public' => true,
        'has_archive' => false,
        'exclude_from_search' => true,
        'menu_position' => 5,
        'supports' => array( 'title'),
        'taxonomies'=> array('category','post_tag'),
        'menu_icon'=> get_template_directory_uri().'/settings/img/shop.png'
        )
    );
}
add_filter('post_type_link', 'custom_product_link', 1, 3);
function custom_product_link( $link, $post = 0 ){
    if ( $post->post_type == 'product' ){
        return home_url( 'product/' . $post->ID .'.html' );
    } else {
        return $link;
    }
}
add_action( 'init', 'custom_product_rewrites_init' );
function custom_product_rewrites_init(){
    add_rewrite_rule(
        'product/([0-9]+)?.html$',
        'index.php?post_type=product&p=$matches[1]',
        'top' );
    add_rewrite_rule(
        'product/([0-9]+)?.html/comment-page-([0-9]{1,})$',
        'index.php?post_type=product&p=$matches[1]&cpage=$matches[2]',
        'top'
        );
}
add_filter( 'manage_edit-product_columns', 'product_custom_columns' );
function product_custom_columns( $columns ) {
    $columns = array(
    	'title' => '标题',
        'desc' => '简介',
        'thumbnail' => '图标',
        'zz' => '作者',
        'pid'=>'小程序ID'
    );
    return $columns;
}
add_action( 'manage_product_posts_custom_column', 'product_manage_custom_columns', 10, 2 );
function product_manage_custom_columns( $column, $post_id ) {
    global $post;
    switch( $column ) {  	
        case "desc":
			$title1 = get_post_meta($post->ID, "single_description", true);
			if($title1){
				echo $title1;
			}
            break;		
        case "thumbnail":
            $thumb_url = get_post_meta($post->ID, "product_pic", true);
            if($thumb_url){
			echo '<img src="'.$thumb_url.'" width="50" height="50" alt="" />';
			}
            break;		
        case "zz":
			$zz1 = get_post_meta($post->ID, "product_zuozhe", true);
			if($zz1){
				echo $zz1;
			}
            break;	
        case "pid":
			echo $post->ID;
            break;  							
        default :
            break;
    }
}
$anli_boxinfo = array('title' => '编辑小程序', 'id'=>'product', 'page'=>array('product'), 'context'=>'normal', 'priority'=>'low', 'callback'=>'');
$anli_metas[] = array(
  'name' => '作者',
  'desc' => '不写则不显示',
  'id' => 'product_zuozhe',
  'type' => 'text'
);
$anli_metas[] = array(
  'name' => '描述',
  'desc' => '填写小程序描述',
  'id' => 'single_description',
  'type' => 'textarea'
);
$anli_metas[] = array(
  'name' => '说明',
  'desc' => '填写说明，没有就不显示',
  'id' => 'product_sm',
  'type' => 'textarea'
);
$anli_metas[] = array(
  'name' => '小程序图标',
  'desc' => '图片大小：120*120',
  'button_label'=>'上传',
  'id' => 'product_pic',
  'type' => 'upload'
);
$anli_metas[] = array(
  'name' => '小程序二维码',
  'desc' => '图片大小：203*203',
  'button_label'=>'上传',
  'id' => 'product_ewm',
  'type' => 'upload'
);
$anli_metas[] = array(
  'name' => '应用图片',
  'id'   => 'product_img',
  'desc' => '最小宽建议：267px',
  'button_text' => 'Add images',
  'type' => 'gallery',
  'multiple' => 'false'
);
$ashuwp_anli = new ashuwp_postmeta_feild($anli_metas, $anli_boxinfo);
?>